using Boyum.Plugin;
using SAPbouiCOM;

namespace MyFirstPlugin
{
    public class MyPlugin : PluginAdapter
    {
        public MyPlugin()
        {
            //Here you setup a productidentifer and if a license-check should occur. For demo purpose so far just ignore them but they would need to be here 
            //LicenseCheck = true;
            //ProductIdentifier = "LBSI_PLUGIN1";
        }

        public override void SetupLanguage()
        {
            base.SetupLanguage();
            //This method is called during startup
            //Here you have the option to prepare any RESX Language files
        }

        public override void SetupMenuItems()
        {
            base.SetupMenuItems();
            //This method is called during startup and language change in Business One.
            //Todo - Add your logic for your needed Menu-items
        }

        public override void SetupTables(ref bool metadataChanges)
        {
            base.SetupTables(ref metadataChanges);
            //This method is called during startup
            //Todo - Add plugins required Userdefined Tables. You should check if Table allready exist and if it does not recreate it. 
            //Todo - If you create any Tables during the method you should set the metadataChanges bool to true
        }

        public override void SetupFields(ref bool metadataChanges)
        {
            base.SetupFields(ref metadataChanges);
            //This method is called during startup
            //Todo - Add plugins required Userdefined Fields. You should check if UDF allready exist and if it does not recreate it. 
            //Todo - If you create any UDFs during the method you should set the metadataChanges bool to true
        }

        public override void SetupKeys(ref bool metadataChanges)
        {
            base.SetupKeys(ref metadataChanges);
            //This method is called during startup
            //Todo - Add plugins required Userdefined Keys. You should check if Key allready exist and if it does not recreate it. 
            //Todo - If you create any Keys during the method you should set the metadataChanges bool to true
        }

        public override void SetupUDO(ref bool metadataChanges)
        {
            base.SetupUDO(ref metadataChanges);
            //This method is called during startup
            //Todo - Add plugins required Userdefined Objects. You should check if object allready exist and if it does not recreate it. 
            //Todo - If you create any Objects during the method you should set the metadataChanges bool to true
        }

        public override void SetupData()
        {
            base.SetupData();
            //This method is called during startup
            //Todo - Add default configurations to tables, etc.
        }

        public override AddonEventFilter SetupEventFilter()
        {
            //Todo - Called during startup and build plugins event-filter (This is a bit different from core SDK so below are a sample)
            //EventFilter.Add(BoEventTypes.et_FORM_LOAD, "134", "150"); //Add as many formtypes as needed as params
            //EventFilter.Add(BoEventTypes.et_ITEM_PRESSED, "134");

            return EventFilter;
        }

        public override void SetupUserPermissionTree()
        {
            base.SetupUserPermissionTree();
            //This method is called during startup
            //Todo - Add a custom permission tree if required.
        }

        public override void PostLicenseCheck(bool valid)
        {
            base.PostLicenseCheck(valid);
            //This method is called during startup
            //Todo - If your plugin are under-license check this method inform you if the license is valid (if not you should remove you menuitems etc.)
        }

        public override void ItemEvent(string formUid, ref ItemEvent pVal, out bool bubbleEvent)
        {
            base.ItemEvent(formUid, ref pVal, out bubbleEvent);

            //Todo - Added logic regarding ItemEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        }

        public override void FormDataEvent(ref BusinessObjectInfo businessObjectInfo, out bool bubbleEvent)
        {
            base.FormDataEvent(ref businessObjectInfo, out bubbleEvent);

            //Todo - Added logic regarding FormDataEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        }

        public override void MenuEvent(ref MenuEvent pVal, out bool bubbleEvent)
        {
            base.MenuEvent(ref pVal, out bubbleEvent);

            //Todo - Added logic regarding MenuEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        }

        public override void PrintEvent(ref PrintEventInfo eventInfo, out bool bubbleEvent)
        {
            base.PrintEvent(ref eventInfo, out bubbleEvent);

            //Todo - Added logic regarding PrintEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        }

        public override void ProgressBarEvent(ref ProgressBarEvent pVal, out bool bubbleEvent)
        {
            base.ProgressBarEvent(ref pVal, out bubbleEvent);

            //Todo - Added logic regarding ProgressBarEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
            //(NB: EventFilter.CatchProgressbarEvent need to be set to true in SetupLanguage in order for these events to happen)
        }

        public override void ReportDataEvent(ref ReportDataInfo eventInfo, out bool bubbleEvent)
        {
            base.ReportDataEvent(ref eventInfo, out bubbleEvent);

            //Todo - Added logic regarding ReportdataEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        }

        public override void RightClickEvent(ref ContextMenuInfo eventInfo, out bool bubbleEvent)
        {
            base.RightClickEvent(ref eventInfo, out bubbleEvent);

            //Todo - Added logic regarding RightClickEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        }

        public override void StatusBarEvent(string text, BoStatusBarMessageType messageType)
        {
            base.StatusBarEvent(text, messageType);

            //Todo - Added logic regarding StatusBarEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
            //(NB: EventFilter.CatchStatusbarEvent need to be set to true in SetupLanguage in order for these events to happen)
        }

        public override void RemoveMenuItems()
        {
            base.RemoveMenuItems();
            //This method is called during shutdown/Changle language of the add-on and here you should do your cleanup of create menuitems.
        }
    }
}