﻿Imports Boyum.Plugin
Imports SAPbouiCOM

Public Class MyPlugin
    Inherits PluginAdapter

    Public Sub New()
        'Here you setup a productidentifer and if a license-check should occur. For demo purpose so far just ignore them but they would need to be here 
        'LicenseCheck = True
        'ProductIdentifier = "LBSI_PLUGIN1"
    End Sub

    Public Overrides Sub SetupLanguage()
        MyBase.SetupLanguage()
        'This method is called during startup
        'Here you have the option to prepare any RESX Language files
    End Sub

    Public Overrides Sub SetupMenuItems()
        MyBase.SetupMenuItems()
        'This method is called during startup and language change in Business One.
        'Todo - Add your logic for your needed Menu-items
    End Sub

    Public Overrides Sub SetupTables(ByRef metadataChanges As Boolean)
        MyBase.SetupTables(metadataChanges)
        'This method is called during startup
        'Todo - Add plugins required Userdefined Tables. You should check if Table allready exist and if it does not recreate it. 
        'Todo - If you create any Tables during the method you should set the metadataChanges bool to true
    End Sub

    Public Overrides Sub SetupFields(ByRef metadataChanges As Boolean)
        MyBase.SetupFields(metadataChanges)
        'This method is called during startup
        'Todo - Add plugins required Userdefined Fields. You should check if UDF allready exist and if it does not recreate it. 
        'Todo - If you create any UDFs during the method you should set the metadataChanges bool to true
    End Sub

    Public Overrides Sub SetupKeys(ByRef metadataChanges As Boolean)
        MyBase.SetupKeys(metadataChanges)
        'This method is called during startup
        'Todo - Add plugins required Userdefined Keys. You should check if Key allready exist and if it does not recreate it. 
        'Todo - If you create any Keys during the method you should set the metadataChanges bool to true
    End Sub

    Public Overrides Sub SetupUDO(ByRef metadataChanges As Boolean)
        MyBase.SetupUDO(metadataChanges)
        'This method is called during startup
        'Todo - Add plugins required Userdefined Objects. You should check if object allready exist and if it does not recreate it. 
        'Todo - If you create any Objects during the method you should set the metadataChanges bool to true
    End Sub

    Public Overrides Sub SetupData()
        MyBase.SetupData()
        'This method is called during startup
        'Todo - Add default configurations to tables, etc.
    End Sub

    Public Overrides Function SetupEventFilter() As Boyum.Plugin.AddonEventFilter
        'Todo - Called during startup and build plugins event-filter (This is a bit different from core SDK so below are a sample)
        'EventFilter.Add(BoEventTypes.et_FORM_LOAD, "134", "150") 'Add as many formtypes as needed as params
        'EventFilter.Add(BoEventTypes.et_ITEM_PRESSED, "134")
        Return EventFilter
    End Function

    Public Overrides Sub SetupUserPermissionTree()
        MyBase.SetupUserPermissionTree()
        'This method is called during startup
        'Todo - Add a custom permission tree if required.
    End Sub

    Public Overrides Sub PostLicenseCheck(valid As Boolean)
        MyBase.PostLicenseCheck(valid)
        'This method is called during startup
        'Todo - If your plugin are under-license check this method inform you if the license is valid (if not you should remove you menuitems etc.)
    End Sub

    Public Overrides Sub ItemEvent(formUid As String, ByRef pVal As SAPbouiCOM.ItemEvent, ByRef bubbleEvent As Boolean)
        MyBase.ItemEvent(formUid, pVal, bubbleEvent)
        'Todo - Added logic regarding ItemEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
    End Sub

    Public Overrides Sub FormDataEvent(ByRef businessObjectInfo As SAPbouiCOM.BusinessObjectInfo, ByRef bubbleEvent As Boolean)
        MyBase.FormDataEvent(businessObjectInfo, bubbleEvent)
        'Todo - Added logic regarding FormDataEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
    End Sub

    Public Overrides Sub MenuEvent(ByRef pVal As SAPbouiCOM.MenuEvent, ByRef bubbleEvent As Boolean)
        MyBase.MenuEvent(pVal, bubbleEvent)
        'Todo - Added logic regarding MenuEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
    End Sub

    Public Overrides Sub PrintEvent(ByRef eventInfo As SAPbouiCOM.PrintEventInfo, ByRef bubbleEvent As Boolean)
        MyBase.PrintEvent(eventInfo, bubbleEvent)
        'Todo - Added logic regarding PrintEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
    End Sub

    Public Overrides Sub ProgressBarEvent(ByRef pVal As SAPbouiCOM.ProgressBarEvent, ByRef bubbleEvent As Boolean)
        MyBase.ProgressBarEvent(pVal, bubbleEvent)
        'Todo - Added logic regarding ProgressBarEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        '(NB: EventFilter.CatchProgressbarEvent need to be set to true in SetupLanguage in order for these events to happen)
    End Sub

    Public Overrides Sub ReportDataEvent(ByRef eventInfo As SAPbouiCOM.ReportDataInfo, ByRef bubbleEvent As Boolean)
        MyBase.ReportDataEvent(eventInfo, bubbleEvent)
        'Todo - Added logic regarding ReportdataEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
    End Sub

    Public Overrides Sub RightClickEvent(ByRef eventInfo As SAPbouiCOM.ContextMenuInfo, ByRef bubbleEvent As Boolean)
        MyBase.RightClickEvent(eventInfo, bubbleEvent)
        'Todo - Added logic regarding RightClickEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
    End Sub

    Public Overrides Sub StatusBarEvent(text As String, messageType As SAPbouiCOM.BoStatusBarMessageType)
        MyBase.StatusBarEvent(text, messageType)
        'Todo - Added logic regarding StatusBarEvents here (If you have no events you can remove the method as Plug-in adapter have a default implementation)
        '(NB: EventFilter.CatchStatusbarEvent need to be set to true in SetupLanguage in order for these events to happen)
    End Sub

    Public Overrides Sub RemoveMenuItems()
        MyBase.RemoveMenuItems()
        'This method is called during shutdown/Changle language of the add-on and here you should do your cleanup of create menuitems.
    End Sub
End Class
